/*
 * i2c_slave_att1.c
 *
 * Created: 28.07.2012 14:56:56
 *  Author: yaha
 */ 

#include <avr/io.h>
#include <string.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include <avr/interrupt.h>

#include "i2c.h"
#include "UART_routines.h"


#define LOCAL_ADDR 0x06
#define TARGET_ADDR 0xA0 

unsigned char buf[40];
//unsigned char byteToSend;
// slave operations 
void i2cSlaveReceiveService(u08 receiveDataLength, u08* receiveData) 
{ 
   sprintf(buf,"slave received: %s (length %d)",receiveData,receiveDataLength);
   transmitString(buf);TX_NEWLINE;
} 

u08 i2cSlaveSendService(u08 transmitDataLength, u08* byteToSend)
{
   
   *byteToSend= 0x11;//     byteToSend
 
  //sprintf(buf,"slave sent: %s (length %d)",byteToSend,transmitDataLength);
  // transmitString(buf);
  //TX_NEWLINE;
   return 1;  //     
}
int main(void)
{
	DDRB= 0b11111111;
	PORTB=0b00000000;
	
	uart0_init();
	//_delay_ms(10);
	sendStr0("*************TWI SLAVE RUNNING*************");

	// initialize i2c function library 
  	i2cInit(); 
  	// set local device address and allow response to general call 
  	i2cSetLocalDeviceAddr(LOCAL_ADDR, TRUE); 
	
	i2cSetSlaveReceiveHandler( i2cSlaveReceiveService ); 
	i2cSetSlaveTransmitHandler(i2cSlaveSendService    );

	while(1)
	{
		_delay_ms(100);
	}
}